<?php

/*
Plugin Name: Get Option by AJAX
Description: Plugin allow to get certain options with asynchronus request (AJAX).
Version: trunk
Author: Marcin Pietrzak
Author URI: http://iworks.pl/
License: GPLv2 or later
License URI: http://www.gnu.org/licenses/gpl-2.0.html
*/

/*

Copyright 2013 Marcin Pietrzak (marcin@iworks.pl)

this program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as 
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

class Iworks_Ajax_Get_Option
{
    private $action_name;
    private $option_name = 'option_name';
    /**
     * allowed options names
     */
    private $allowed_option_name = array(
        'blogname',
        'admin_email',
        'blogdescription',
    );

    public function __construct()
    {
        $this->action_name = strtolower( __CLASS__ );
        add_action( 'wp_ajax_nopriv_'.$this->action_name, array( &$this, 'callback' ) );
        add_action( 'wp_ajax_'.$this->action_name, array( &$this, 'callback' ) );
        add_action( 'wp_enqueue_scripts', array( &$this, 'wp_enqueue_scripts' ) );
        add_action( 'wp_head', array( &$this, 'wp_head' ) );
    }

    public function wp_enqueue_scripts()
    {
        wp_enqueue_script( 'jquery' );
    }

    public function callback()
    {
        /**
         * check exist?
         */
        if ( !isset( $_POST[$this->option_name] ) or empty( $_POST[ $this->option_name ] ) ) {
            return;
        }
        /**
         * check allows keys!
         */
        if ( in_array( $_POST[ $this->option_name ], $this->allowed_option_name ) ) {
            echo get_option( $_POST[ $this->option_name ] );
        }
        die();
    }

    public function wp_head()
    {
?>
        <script>
        jQuery(document).ready(function($) {
            var data = {
                action: '<?php echo $this->action_name; ?>',
                <?php echo $this->option_name; ?>: 'admin_email'
            };
            jQuery.post( '<?php echo admin_url('admin-ajax.php'); ?>', data, function(response) {
                alert('Got this from the server: ' + response);
            });
        });
        </script>
<?php
    }

}
new Iworks_Ajax_Get_Option();

